'use strict';

module.exports = function(grunt) {
    require('load-grunt-tasks')(grunt);
    require('time-grunt')(grunt);

    var appConfig = {
        app: require('./bower.json'),
        dist: 'dist'
    };

    // Options
    var options = {
        accountant: appConfig,

        config: {
            src: 'grunt-config/*.js'
        },
        paths: {
            frontend_js: [
                'accountant/frontend/static/js/*.js'
            ],
            frontend_build: 'accountant/frontend/static/build'
        },
        pkg: grunt.file.readJSON('package.json'),
        banner: '/*! <%= pkg.name %> <%= grunt.template.today("dd-mm-yyyy") %>\n'+
          '* Copyright (c) <%= grunt.template.today("yyyy") %> <%= pkg.author %> */\n',
    };

    var configs = require('load-grunt-configs')(grunt, options);
    grunt.initConfig(configs);

    grunt.registerTask('dependencies', [
        'shell:npm_install',
        'shell:bower_install',
        'shell:pip_install',
        'wiredep:app',
    ]);

    grunt.registerTask('pydev', [
        'newer:flake8'
    ]);

    grunt.registerTask('jsdev', [
        'newer:jshint',
        'newer:jscs'
    ]);

    grunt.registerTask('htmldev', [
        'newer:htmllint'
    ]);

    grunt.registerTask('dev', [
        'dependencies',
        'pydev',
        'jsdev',
        'htmldev'
    ]);

    grunt.registerTask('serve', [
        'dev',
        'bgShell:runserver',
        'watch'
    ]);
};
